"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
class CompilerOutRootFiles {
    constructor() {
        this.files = [];
    }
    /** Returns true if list of rootNames is changed */
    update(rootNames, inDir, outDir) {
        let isChanged = false;
        if (!rootNames || !rootNames.length) {
            if (this.files.length) {
                isChanged = true;
            }
            this.files = [];
        }
        else {
            // remove output files that was deleted
            this.files.forEach((v, i) => {
                if (!rootNames.includes(v.rootName)) {
                    isChanged = true;
                    this.files.splice(i, 1);
                }
            });
            // add new rootNames
            rootNames.forEach(rootName => {
                const ePath = rootName.replace(/(.ts)$/, ".js");
                const outPath = path_1.default.join(outDir, path_1.default.relative(inDir, ePath));
                if (!this.files.find(f => f.path === outPath)) {
                    isChanged = true;
                    this.files.push({ path: outPath, rootName });
                }
            });
        }
        return isChanged;
    }
}
exports.default = CompilerOutRootFiles;
