import { Application as ExpressApp } from "express";
import { MockServerHelper } from "./mockServerHelper";
import MockServerOptions from "./mockServerOptions";
declare const webpackMockServer: {
    /**
     * Applies wepackMiddleware on existed express-application
     * @param app expressjs application that is used for mapping-routes
     * @param extendOptions MockServerOptions that overrides default options
     */
    use(app: ExpressApp, extendOptions?: MockServerOptions | undefined): void;
    /**
     * Add mock functions into webackMockServer
     * @param mockFunction
     */
    add(mockFunction: (app: ExpressApp, helper: MockServerHelper) => void): (app: ExpressApp) => void;
    /** Default MockServer options (readonly) */
    readonly defaultOptions: MockServerOptions;
};
export = webpackMockServer;
