"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
let isFirst = true;
const log = {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    info(message, uri, ...optionalParams) {
        console.info(`\nWebpackMockServer. ${message} \u001b[1m\u001b[34m${uri ||
            ""}\n\u001b[39m\u001b[22m`, ...optionalParams);
    },
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    debug(message, uri = "", ...optionalParams) {
        if (!this.verbose) {
            return;
        }
        console.info(`${isFirst ? "\n" : "" // add new-line - fix for webpack.logger
        }WebpackMockServer: ${message} \u001b[1m\u001b[34m${uri}\u001b[39m\u001b[22m`, ...optionalParams);
        isFirst = false;
    },
    error(message, ex = undefined, 
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    ...optionalParams) {
        console.error("\x1b[31m", // set red color
        `\nWebpackMockServer. ${message}`, ex || "", "\x1b[0m", // reset color
        "\n", // set new line
        ...optionalParams);
    },
    verbose: true
};
exports.default = log;
